import { timerIds } from "./state";

export default class {
  execute(properties, component) {
    component.$data._isBusy = true;
    const { timerId, repeat, interval } = properties;

    // clear timeout/interval if there is same timerId exist
    if (timerId && timerIds[timerId]) {
      repeat ? clearInterval(timerIds[timerId]) : clearTimeout(timerIds[timerId]);
      delete timerIds[timerId];
    }

    let id = null;
    if (repeat) {
      id = setInterval(() => {
        this.onTimeout(properties, component);
      }, interval);
    } else {
      id = setTimeout(() => {
        this.onTimeout(properties, component);
      }, interval);
    }

    if (properties.timerId) {
      timerIds[properties.timerId] = id;
    }
  }

  onTimeout(properties, component) {
    component.$data._isBusy = false;
    GLib.action.execute(properties.onTimeout, component);
  }
}
